{{ MAIN  test programm for Stepper PWM generation }}
{CMap0271_Prj02653_Referenzprj_Propeller_Stepperantrieb}
{{
12.09.2009 na: included variable KnowAngl as the determined angle
12.09.2009 na: included measuring of DC-link voltage, dynamically adjust offset BEMF
27.08.2009 na: Recoded function "Measure Motor" ("5")
26.08.2009 na: Pong Frequency division factor determined by PongShft
02.08.2009 na: Start procedure now corrects offset to pointers
28.07.2009 na: Proceed with documentation in simple english
26.05.2009 na: Umstellen des Sextanten auf 0-5, Entfernen *256
Dient zum Testen des parallelen Visualisierungsprozesses
}}


CON
  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000
 
'Functions of the main programm
  #0, KIdle, KInit, KPing, KPong, KPiPo, KMess, KCatc, KRunE, KRunK, KACIM, KEmer
'Commands for visualization
  #1, Idle, Run, CleaScre, DispText, DispGrph
'Commands for PWM Generator
  #3,            PWM_Par
'Commands for serial communication process to external Serial IO: FD, LIN, ...
  #3,            ParReLoa, LIN_Msg
'Commands for Propeller to Propeller communication
  ' nothing new just now #3,            ParReLoa

  {{ Selecting PWM-frequency:

     the PWM-frequency is about 20 kHz to omit audible noise. Having a clock frequency of 80 MHz, a cycle is about 4000 ticks.
     to ease the computation of DuFPuls and DuFPause 4096 ticks are selected, so division becomes just a shift. PWM-frequency: 19.53 kHz
   
    'Eigentlich:   PWMCyclS :=   ClkFreq / PWMFreq = 4000 ' PWMFrequenz. z.B. 20 kHz
                      'Uneigentlich: PWMCyclS :=   1 << 12           = 4096 ' ca 20 KHz wg. Multiplikation beim Normieren PWMDuty
                      ' hier 80MHZ / 4096 = 19.53 kHz PWM
   }}

'' mode bit 0 = invert rx                                                               
'' mode bit 1 = invert tx                                                               
'' mode bit 2 = open-drain/source tx                                                    
'' mode bit 3 = ignore tx echo on rx  ?
mbHalfDup = 16 '' mode bit 4 = half duplex                                                  
'' mode bit 5 = rx only                                                
'' mode bit 6 = tx only       sets open drain to deactivate output pin!                                         
  txpin   = 14                                                    
  rxpin   = 15

  Stxpin   = 15                                                    
  Srxpin   = 14
  
  defbdrat = 1024*1024/14' 800'1024 ' 9600  '
  defMode = mbHalfDup + 0 '3 ' inverted pins : rx / tx inverted


CON      AnzPWM_Par = 12'07 ' Seven pointers for the PWM process
Dat PrCBPWM_ long  @PWM_Cmd, @PWMPrdy, @PWMCycl, @PWMPatt, @PWMMode, @PWMTra1, @PWMTra2, @OutPatt,@NxtPatt,@NxtTra1,@NxtTra2,@PWMSTim    


Dat                                                                           
{{
Der bersichtlichkeit halber fr die Situation der Programmentwicklung werden hier alle Variablen zusammengefasst,
die ber den Prozessblock kommuniziert werden. Die erste Stelle des Kommentars enthlt die Parameternummer,
auch wenn der Parameter auf einen sprechenden Namen bekommt. Damit ist der Zusammenhang zur Visualisierung
etwas einfacher nachzuvollziehen.
}}


PWM_Cmd     long  0   ' to control the PWM process
PWMPrdy     long  0   ' Flag: new parameter set ready
PWMCycl     long  0   ' Cycle time                                                         
PWMNeut     long  0   ' Neutral value: 50% DutyCycle                                                       
PWMPatt     long  0   ' Number of PWM Pattern Group                                       
PWMMode     long  0   ' Mode: 0: normal mode, 1: only 1 transition, 2: no transition at all
PWMTra1     long  0   ' The first transition                                               
PWMTra2     long  0   ' The second transition                                              

OutPatt     long  0   ' Pointer to the actual pattern to output
NxtPatt     long  0   ' Pointer to pattern of next cycle
NxtTra1     long  0   ' The first transition of this cycle                                              
NxtTra2     long  0   ' The second transition of this cycle
PWMSTim     long  0   ' start of the next cycle

Angle       long  0   ' Rotor angle
AnglTmp     long  0   ' Temporary angle value
AnglStp     long  0   ' Increment in stepping angle
AnglStD     long  1   ' direction of angle stepping
PWMCyclS    long  0   ' The initial setvalue for PWM Cycle time (actual value may be different)                                             

ScreCmd  long  0  '001 Das Kommando fr die Screen-Darstellung                                                                              
ActState long 003 '003 Zustandsnummer   Siehe auch NxtState                          
Aktion   long 004 '004 RunModus  Spannung, ...  Ein Hilfsstatus: zeigt die Aktion im aktuellen Aktion                       
KeyBoCmd long 005 '005 ber die Tastatur (oder Taste) eingegebenes Zeichen      
VersDate byte "12.10.2009 a na", 0 '006


ScVal037     long  0   ' The keyboard input (0-9 hex)                                         


OBJ                                                                      
  PWM   : "Stpr_PWM__ASM"       ' Simple PWM Generation for two H-Bridges

        dbg     : "BgWatch"
        kb      : "pc_keyboard"

PUB Main | i

  'start the watcher (uses 1 cog)
  dbg.start(30)     '(pin 30 for TX)
  'define the variables to watch
'' Adds a variable to watch -- returns true if ok
''
'' row:   row 1..10 on Display
'' addr:  pointer to variable or -1 = Off
'' label: Type and variable-shortname
''   first char in label: 'B'=byte 'W'=word 'L'=long 'S'=CogRAM(long)  other=long
''   second char in label: '$'=hex '%'=binary '=char  other=decimal (long:signed; word,byte:unsigned)
'' size:  number of contiguous values to show ( > 1 = array)
  dbg.watch_var(02,@PWM_Cmd,string("L PWM_Cmd"),1)    'L: long   " " decimal , length (array)
  dbg.watch_var(03,@PWMPrdy,string("L PWMPrdy"),1)    
  dbg.watch_var(04,@PWMCycl,string("L PWMCycl"),1)    
  dbg.watch_var(05,@PWMPatt,string("L PWMPatt"),1)
  dbg.watch_var(06,@PWMMode,string("L PWMMode"),1)    
  dbg.watch_var(07,@PWMTra1,string("L PWMTra1"),1)
  dbg.watch_var(08,@PWMTra2,string("L PWMTra2"),1)
  dbg.watch_var(09,@OutPatt,string("L OutPatt"),1)    
'  dbg.watch_var(10,@NxtPatt,string("L NxtPatt"),1)    
'  dbg.watch_var(11,@NxtTra1,string("L NxtTra1"),1)
'  dbg.watch_var(12,@NxtTra2,string("L NxtTra2"),1)    
'  dbg.watch_var(13,@PWMSTim,string("L PWMSTim"),1)

' my code
  PWMCyclS :=   1 << 12           ' Counter counts 4096 clocks per cycle, about 20 kHz

  PWMCycl  :=   PWMCyclS          ' Cycle time                                                         
  PWMNeut  :=   PWMCycl >> 1
'  PWMNeut  :=   0
  PWMPatt  :=   2                 ' Number of PWM Pattern Group (Mode2: octant 0-7)                                       
  PWMMode  :=   2                 ' Mode: number of transitions!
  PWMTra1  :=   PWMCyclS/2           ' The first transition                                               
  PWMTra2  :=   PWMCyclS/3+ PWMTra1  ' The second transition                                              
  PWMTra1  :=   PWMTra2          ' The first transition                                               

  PWMPrdy  :=   1   ' Flag: new parameter set ready


  
  ' Start all necessary processes and have them running idle

  PWM_Cmd  := AnzPWM_Par     ' PWM_Cmd initially determines number of parameters copied
  i        := PWM.start(@PrCBPWM_, @@0) -1  ' Erzeugen der PWM-Signale       '
  ActState := CmdInvok (@PWM_Cmd, Idle, i)

  ' initialize them main program
  
  ActState := 0      ' 
  ScVal037 := KInit  '  Start init in main loop
  ' and start to loop forever
  repeat       
               
    case ScVal037


      KIdle:   ' 0
        repeat   ' let us test microstepping            

          outa     ^= %100_0000_0000
          waitcnt (cnt + Clkfreq/500)
          outa     ^= %100_0000_0000

          if AnglStD > 0
            AnglStp := AnglStp + 1
            if AnglStp >40000
              AnglStD := -1
          else
            AnglStp := AnglStp - 1
            if AnglStp < -40000
              AnglStD := +1

              
          Angle := ( Angle + AnglStp>>5 + 1<<13 ) // (1<<13)   ' increment Angle

          AnglTmp := Angle
          ' Determine octant
          if AnglTmp < (1<<12)    ' <180
            if AnglTmp < (1<<11)   ' <90
              if AnglTmp < (1<<10)  ' <45

                 PWMTra1 :=  PWMNeut +   ( sin (Angltmp))  >> 6
                 PWMTra2 :=  PWMNeut +   ( cos (Angltmp))  >> 6
                 PWMPatt := 0

              else                ' >45

                 PWMTra2 :=  PWMNeut +   ( sin (Angltmp))  >> 6
                 PWMTra1 :=  PWMNeut +   ( cos (Angltmp))  >> 6
                 PWMPatt := 1

            else                 ' > 90
              AnglTmp -=  (1<<11)
              if AnglTmp < (1<<10)  ' <135

                 PWMTra1 :=  PWMNeut +   ( sin (Angltmp))  >> 6
                 PWMTra2 :=  PWMNeut +   ( cos (Angltmp))  >> 6
                 PWMPatt := 2

              else                ' >135

                 PWMTra2 :=  PWMNeut +   ( sin (Angltmp))  >> 6
                 PWMTra1 :=  PWMNeut +   ( cos (Angltmp))  >> 6
                 PWMPatt := 3


          else     ' angle >180


            AnglTmp -=  (1<<12)

            if AnglTmp < (1<<11)   ' <90
              if AnglTmp < (1<<10)  ' <45

                 PWMTra1 :=  PWMNeut +   ( sin (Angltmp))  >> 6
                 PWMTra2 :=  PWMNeut +   ( cos (Angltmp))  >> 6
                 PWMPatt := 4

              else                ' >45

                 PWMTra2 :=  PWMNeut +   ( sin (Angltmp))  >> 6
                 PWMTra1 :=  PWMNeut +   ( cos (Angltmp))  >> 6
                 PWMPatt := 5

            else                 ' > 90
              AnglTmp -=  (1<<11)
              if AnglTmp < (1<<10)  ' <135

                 PWMTra1 :=  PWMNeut +   ( sin (Angltmp))  >> 6
                 PWMTra2 :=  PWMNeut +   ( cos (Angltmp))  >> 6
                 PWMPatt := 6

              else                ' >135

                 PWMTra2 :=  PWMNeut +   ( sin (Angltmp))  >> 6
                 PWMTra1 :=  PWMNeut +   ( cos (Angltmp))  >> 6
                 PWMPatt := 7


'          PWMTra1 :=  2048 '+   500
'                 PWMTra2 :=  2048 +   500
           



          PWMPrdy  :=   1   ' Flag: new parameter set ready



      KInit:    ' 1
        ActState := CmdInvok (@PWM_Cmd, Run, 6)
        ScVal037 := KIdle
        dira     := %1100_0000_0000
   
      KACIM:
        ' tun
        ScVal037 := KIdle

                                                                    


PUB Sin (phi) | Vorz
      Phi := Phi // 1<<13
      VorZ := 1
      'PhiInt := PhiTest
      if Phi > 4095
        Phi -= 4096
        VorZ :=-1
      If Phi > 2047
        Phi := 4096 - Phi  
      return VorZ * word[$E000 + Phi<<1]

PUB Cos (phi) | Vorz
      Phi := (Phi + 2048) // 1<<13
      VorZ := 1
      'PhiInt := PhiTest
      if Phi > 4095
        Phi -= 4096
        VorZ :=-1
      If Phi > 2047
        Phi := 4096 - Phi  
      return VorZ * word[$E000 + Phi<<1]

PRI CmdInvok (CmdPtr, Cmd, Stat) ' Wait until process idle, output cmd, wait for acknowledge, return "Stat" for documentation/debuging purposes
    repeat while long[CmdPtr]
    long[CmdPtr] := Cmd  
    repeat while long[CmdPtr]
    Result := Stat

